Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package ast
  Definition Classes
    nsc
-  trait TreeDSL extends AnyRef

  A DSL for generating scala code.

  A DSL for generating scala code. The goal is that the code generating code should look a lot like the code it generates.

  Definition Classes
    ast
- CODE

o

scala.tools.nsc.ast.TreeDSL

# CODE

###

#### object CODE

Source
  TreeDSL.scala

Linear Supertypes
AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. CODE
2. AnyRef
3. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Type Members

1.  class CaseStart extends AnyRef
2.  class IfStart extends AnyRef
3.  case class SelectStart(tree: Global.Select) extends Product with Serializable
4.  class TreeMethods extends AnyRef
5.  class TryStart extends AnyRef

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def AND(guards: Global.Tree*): Global.Tree
5.  def BLOCK(xs: Global.Tree*): Global.Block
6.  def CASE(pat: Global.Tree): CaseStart
7.  def DEFAULT: CaseStart
8.  def FALSE: Global.Literal
9.  def IF(tree: Global.Tree): IfStart
10.  def NEW(tpt: Global.Tree, args: Global.Tree*): Global.Tree
11.  def NOT(tree: Global.Tree): Global.Select
12.  def NULL: Global.Literal
13.  def REF(pre: Global.Type, sym: Global.Symbol): Global.RefTree
14.  def REF(sym: Global.Symbol): Global.RefTree

    Typed trees from symbols.

15.  def SOME(xs: Global.Tree*): Global.Tree
16.  def TRUE: Global.Literal
17.  def TRY(tree: Global.Tree): TryStart
18.  def UNIT: Global.Literal
19.  def ZERO: Global.Literal
20.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
21.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
22.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
23.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
24.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
25.  def fn(lhs: Global.Tree, op: Global.Symbol, args: Global.Tree*): Global.Apply
26.  def fn(lhs: Global.Tree, op: Global.Name, args: Global.Tree*): Global.Apply
27.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
28.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
29.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
30.  implicit def mkTreeFromSelectStart(ss: SelectStart): Global.Select

    (foo DOT bar) might be simply a Select, but more likely it is to be immediately followed by an Apply.

    (foo DOT bar) might be simply a Select, but more likely it is to be immediately followed by an Apply. We don't want to add an actual apply method to arbitrary trees, so SelectStart is created with an apply - and if apply is not the next thing called, the implicit from SelectStart -> Tree will provide the tree.

31.  implicit def mkTreeMethods(target: Global.Tree): TreeMethods

    Implicits - some of these should probably disappear *

32.  implicit def mkTreeMethodsFromSelectStart(ss: SelectStart): TreeMethods
33.  implicit def mkTreeMethodsFromSymbol(target: Global.Symbol): TreeMethods
34.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
35.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
36.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
37.  def nullSafe[T](f: (Global.Tree) => Global.Tree, ifNull: Global.Tree): (Global.Tree) => Global.Tree
38.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
39.  def toString(): String
    Definition Classes
      AnyRef → Any
40.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
41.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
42.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
43.  object END
44.  object LIT extends (Any) => Global.Literal

### Inherited from AnyRef

### Inherited from Any

### Ungrouped